var PREFS = null;
var ENABLE_TIME_INSERT_PREF = "extensions.ebayends.inserttime";
var DESIRED_TIME_FORMAT_PREF = "extensions.ebayends.timeformat";
var dTimeFormat = "";
var doDump = true;

var aDay = new Array();
aDay[0] = "T";  //german
aDay[1] = "d";  //english
aDay[2] = "g";  //italiano
aDay[3] = "d";  //netherland
aDay[4] = "j";  //french
var aHour = new Array();
aHour[0] = "Std";
aHour[1] = "h";
aHour[2] = "h";
aHour[3] = "u";
aHour[4] = "h";
var aMin = new Array();
aMin[0] = "Min";
aMin[1] = "m";
aMin[2] = "m";
aMin[3] = "m";
aMin[4] = "m";

function debug(aMsg) {
   setTimeout(function() { throw new Error("[debug] " + aMsg); }, 0);
}

function getDocument() {
	//	return document;
	return window._content.document;
}

function setEEIcon(onOff) {
	if (!window.statusbar.visible) {
		return;
	}
	var locale = document.getElementById('ebayends-strings');
	if (document.getElementById('ebayends-status')) {
		document.getElementById('ebayends-status').setAttribute("status", onOff ? "1" : "0");
		document.getElementById('ebayends-tooltip-value').setAttribute("value", !onOff ? locale.getString("ebayEndsDisabled") : locale.getString("ebayEndsEnabled"));
	}
}

function isMyEbay(href) {
	/*var temp = href;
	temp = temp.slice(temp.lastIndexOf('&CurrentPage=') + 13, temp.indexOf('&ssPageName='));
	if(temp.toLowerCase() == "myebaywatching" || temp.toLowerCase() == "myebaysummary" || temp.toLowerCase() == "myebayallbuying") { // || temp.toLowerCase() == "myebaysummary" || temp.toLowerCase() == "myebayallbuying"
		return true;
	} else {
		return false;
	}*/
	if (href.indexOf('CurrentPage=MyeBayWatching') > 0 || href.indexOf('CurrentPage=MyeBayAllBuying') > 0 || href.indexOf('CurrentPage=MyeBaySummary') > 0 || href.indexOf('MyeBay') > 0) {
		return true;
	} else {
		return false;
	}
}

String.prototype.leftTrim = function () {
	return (this.replace(/^\s+/,""));
};
String.prototype.rightTrim = function () {
	return (this.replace(/\s+$/,""));
};
//kombiniert "leftTrim" und "rightTrim";
String.prototype.basicTrim = function () {
	return (this.replace(/\s+$/,"").replace(/^\s+/,""));
};
//dampft leerzeichen(-sequenzen) innerhalb einer zeichenkette auf ein einzelnes "space" ein;
String.prototype.superTrim = function () {
	return(this.replace(/\s+/g," ").replace(/\s+$/,"").replace(/^\s+/,""));
};

//zugabe: entfernt alle leerzeichen aus einer zeichenkette;
String.prototype.removeWhiteSpaces = function () {
	return (this.replace(/\s+/g,""));
};


window.addEventListener("load", function() { ebayends.init(); }, false);
var ebayends = {
  init: function() {
    this.initialized = true;
    this.strings = document.getElementById("ebayends-strings");var nsIPrefBranch_default = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
	var showStatusbarIcon = nsIPrefBranch_default.getBoolPref("extensions.ebayends.statusbarvisible");
	if (showStatusbarIcon == false) { 
		//document.getElementById("ebayends-status").removeAttribute("class"); 
		document.getElementById("status-bar").removeChild(document.getElementById("ebayends-status"));
	}
	var nsIPrefBranch_default = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
	var showIt = nsIPrefBranch_default.getBoolPref("extensions.ebayends.inserttime");
	setEEIcon(showIt);
	if (doDump == true) {dump('ebayends.onLoad started...\n');}
	var appcontent = document.getElementById("appcontent");   // browser
	if(appcontent)
		appcontent.addEventListener("load", this.onPageLoad, true);
  },
  onPageLoad: function(aEvent) {	
	var nsIPrefBranch_default = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
	var showIt = nsIPrefBranch_default.getBoolPref("extensions.ebayends.inserttime");
	if (doDump == true) { dump('inserttime = ' + showIt + '\n'); }
	setEEIcon(showIt);
	var doc = aEvent.originalTarget; // doc is document that triggered "onload" event
    // do something with the loaded page.
    // doc.location is a Location object (see below for a link).
    // You can use it to make your code executed on certain pages only.	
	CheckPage(doc);
  },
  onMenuItemCommand: function(e) {
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                  .getService(Components.interfaces.nsIPromptService);
    promptService.alert(window, this.strings.getString("helloMessageTitle"),
                                this.strings.getString("helloMessage"));
  },
  onToolbarButtonCommand: function(e) {
    // just reuse the function above.  you can change this, obviously!
    ebayends.onMenuItemCommand(e);
  },
  openConfig: function() {
  	if (doDump == true) { dump('EbayEnds.openConfig clicked...\n'); }
    if(this.initialized)
       window.open("chrome://ebayends/content/options.xul", "ebayends-config", "chrome,width=800,height=450");
  },
  onEEStatusBarClick: function() {
  	if (doDump == true) { dump('EbayEnds.onEEStatusBarClick started...\n'); }
	var nsIPrefBranch_default = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
	var showIt = nsIPrefBranch_default.getBoolPref("extensions.ebayends.inserttime");
	if (doDump == true) { dump("pref = " + showIt + "\n"); }
    if(!showIt){
    	nsIPrefBranch_default.setBoolPref(ENABLE_TIME_INSERT_PREF, true);
		getDocument().location.reload();
    }
    else {
    	nsIPrefBranch_default.setBoolPref(ENABLE_TIME_INSERT_PREF, false);
    	getDocument().location.reload();
    }
	showIt = !showIt;
	if (doDump == true) { dump(showIt + ' for Statuspanelimage selected...\n'); }
    setEEIcon(showIt);
	return true;
  }

};

function CheckPage(doc) {
	var nsIPrefBranch_default = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
	var showIt = nsIPrefBranch_default.getBoolPref("extensions.ebayends.inserttime");
	if (showIt) {
		if (doc.location) {
			var url = doc.location.href;
			if(isMyEbay(url)) {
				if (doDump == true) { dump('EE: Yeah, we are at MyEbayWatching :D\n'); }
				ManipulateDocument(doc);
			}
		}
	}


}

function formatTime(tmeTime) {
	var nsIPrefBranch_default = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
	var timeFormat = nsIPrefBranch_default.getCharPref("extensions.ebayends.timeformat");
	var resultingTime = "";
	var strTemp = "";
	for (m=0; m<timeFormat.length; m++) {
		switch (timeFormat.charAt(m)) {
			case "p":
				resultingTime = resultingTime + "<br />";
				break;
			case "d":
				strTemp = tmeTime.getDate() + ""
				if (strTemp.length == 1) {
					strTemp = "0" + strTemp;
				}
				resultingTime = resultingTime + "" + strTemp; strTemp="";
				break;
			case "D":
				var DDays = new Array("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat");
				resultingTime = resultingTime + "" + DDays[tmeTime.getDay()];
				break;
			case "j":
				resultingTime = resultingTime + "" + tmeTime.getDate();
				break;
			case "l":
				var lDays = new Array("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
				resultingTime = resultingTime + "" + lDays[tmeTime.getDay()];
				break;
			case "F":
				var FMonths = new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
				resultingTime = resultingTime + "" + FMonths[(tmeTime.getMonth() + 1)];
				break;
			case "m":
				strTemp = (tmeTime.getMonth() + 1) + "";
				if (strTemp.length == 1) {
					strTemp = "0" + strTemp;
				}
				resultingTime = resultingTime + "" + strTemp; strTemp="";
				break;
			case "M":
				var MMonths = new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
				resultingTime = resultingTime + "" + MMonths[(tmeTime.getMonth())];
				break;
			case "n":
				resultingTime = resultingTime + "" + (tmeTime.getMonth() + 1);
				break;
			case "Y":
				resultingTime = resultingTime + "" + tmeTime.getFullYear();
				break;
			case "y":
				strTemp = tmeTime.getFullYear() + "";
				strTemp = strTemp.slice(2);
				resultingTime = resultingTime + "" + strTemp; strTemp="";
				break;
			case "a":
				if (tmeTime.getHours() > 12) { resultingTime = resultingTime + "pm"; } else { resultingTime = resultingTime + "am"; }
				break;
			case "A":
				if (tmeTime.getHours() > 12) { resultingTime = resultingTime + "PM"; } else { resultingTime = resultingTime + "AM"; }
				break;
			case "g":
				var curAMPM = " AM";
				var strTemp = tmeTime.getHours();
				if (strTemp >= 12){
					strTemp -= 12;
					curAMPM = " PM";
				}
				if (strTemp == 0) curHour = 12;
				resultingTime = resultingTime + "" + strTemp; strTemp="";
				break;
			case "G":
				resultingTime = resultingTime + "" + tmeTime.getHours();
				break;
			case "h":
				var curAMPM = " AM";
				var strTemp = tmeTime.getHours();
				if (strTemp >= 12){
					strTemp -= 12;
					curAMPM = " PM";
				}
				if (strTemp == 0) strTemp = 12;
				if (strTemp.length == 1) {
					strTemp = "0" + strTemp;
				}
				resultingTime = resultingTime + "" + strTemp; strTemp="";
				break;
			case "H":
				strTemp = "" + tmeTime.getHours();
				if (strTemp.length == 1) {
					strTemp = "0" + strTemp;
				}
				resultingTime = resultingTime + "" + strTemp; strTemp="";
				break;
			case "i":
				strTemp = "" + tmeTime.getMinutes();
				if (strTemp.length == 1) {
					strTemp = "0" + strTemp;
				}
				resultingTime = resultingTime + "" + strTemp; strTemp="";
				break;
			case "s":
				strTemp = "" + tmeTime.getSeconds();
				if (strTemp.length == 1) {
					strTemp = "0" + strTemp;
				}
				resultingTime = resultingTime + "" + strTemp; strTemp="";
				break;
			case "u":
				resultingTime = resultingTime + "" + Date.parse(tmeTime);
				break;
			default:
				resultingTime = resultingTime + timeFormat.charAt(m);
				break;
		}
	}
	return resultingTime;
}

function ManipulateDocument(doc) {
	var timeCellXpath = "//td[@class='c_TimeLeft']/div";
	var timeCellXpathRed = "//td[@class='c_TimeLeft']/div[@class='Red']";

	var timeCells = doc.evaluate(timeCellXpath, doc, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	var timeCellsRed = doc.evaluate(timeCellXpathRed, doc, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	
	var cellIdRed = 0;
	var timeCellsRedNode = timeCellsRed.snapshotItem(cellIdRed);
	var timeCellsNode;
	if (doDump == true) { dump('EE: Cells: ' + timeCells.snapshotLength + 'x all\n           ' + timeCellsRed.snapshotLength + 'x red\n'); }
	var tested = false;

	for ( var cellId = 0; cellId < timeCells.snapshotLength; cellId++ ) {
		timeCellsNode = timeCells.snapshotItem(cellId);
		if (doDump == true) { dump('EE: Found TimeLeft Cell...\n'); }
		var timeSpan = timeCellsNode.textContent;
		if (doDump == true) { dump('EE: Time: ' + timeSpan + '\n'); }
		var splitTime = timeSpan.split(" ");
		if (doDump == true) { dump('EE: Splits: ' + splitTime.length + '\n'); }
		var addition = 0;
		if (splitTime.length > 0) {
			for (k=0; k<aDay.length; k++) {
				var used = 0;
				addition = 0;
				for (j=0; j<splitTime.length; j++) {
					if (doDump == true) { dump('Verwende Zeittabelle Nr. ' + j + ' (' + splitTime[j] + ') und Sprache Nr. ' + k + '\n'); }

					if (splitTime[j].indexOf(aDay[k]) > 0) {
						var multi = splitTime[j].slice(0,splitTime[j].indexOf(aDay[k]));
						if (doDump == true) { dump('EE: Day: ' + Math.round(multi) + aDay[k] + " Day Value: " + multi); }
						addition += ((24 * 60 * 60 * 1000) * Math.round(multi));
						if (doDump == true) { dump(' -> ' + addition + '\n'); }
						used = used + 1;
					}
					if (splitTime[j].indexOf(aHour[k]) > 0) {
						var multi = splitTime[j].slice(0,splitTime[j].indexOf(aHour[k]));
						if (doDump == true) { dump('EE: Hour: ' + Math.round(multi) + aHour[k] + " Hour Value: " + multi); }
						addition += ((60 * 60 * 1000) * Math.round(multi));
						if (doDump == true) { dump(' -> ' + addition + '\n');}
						used = used + 1;
					}
					if (splitTime[j].indexOf(aMin[k]) > 0) {
						var multi = splitTime[j].slice(0,splitTime[j].indexOf(aMin[k]));
						if (doDump == true) { dump('EE: Min: ' + Math.round(multi) + aMin[k] + " Minute Value: " + multi); }
						addition += ((60 * 1000) * Math.round(multi));
						if (doDump == true) { dump(' -> ' + addition + '\n'); }
						used = used + 1;
					}
				}
				if (timeCellsRedNode != null) {
					if (doDump == true) { dump('EE: Testing \'' + timeCellsNode.textContent.superTrim() + '\' against \'' + timeCellsRedNode.textContent.superTrim() + '\'\n'); }
					if (timeCellsRedNode.textContent.superTrim() == timeCellsNode.textContent.superTrim() ) {
						used = 3;
						tested = true;
						if (doDump == true) { dump('Yes! Making used = 3\n');}
					}
				}
				if (doDump == true) { dump('Used: ' + used + '\n');}
				if (addition > 0 && used > 2) {
					var Zeit = new Date();
					var timeNow = Zeit.getTime();

					var nsIPrefBranch_default = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
					var timeOffset = nsIPrefBranch_default.getIntPref("extensions.ebayends.timeoffset");
					if (doDump == true) { dump('selected timeoffset: '+timeOffset + '\n');}
					var timeOffsetInt = parseInt(timeOffset) * (60 * 60 * 1000);
					var timeSpan = timeNow + addition + timeOffsetInt;

					Zeit.setTime(timeSpan);
					//var tmpString = Zeit.toLocaleString()
					var displTime = formatTime(Zeit);
					if (doDump == true) { dump ("EE: Trying to add time: " + displTime);}
					//timeCellsNode.textContent =  timeCellsNode.textContent + "\n" + displTime;
					/*var p = document.createElement('p');
					var text = document.createTextNode(displTime);
					p.appendChild(text);
					timeCellsNode.appendChild(p);*/
					timeCellsNode.innerHTML = timeCellsNode.innerHTML + "<br>" + displTime;
					addition = 0;
					k = k.length + 2;
					if (tested == true) {
						cellIdRed++;
						timeCellsRedNode = timeCellsRed.snapshotItem(cellIdRed);
						tested = false;
					}
					if (doDump == true) { dump('\n\n');}
				}
			}
		}	
	}
	if (doDump == true) { dump('       EE-Ends: All done....\n');}
}
